c***********************************************************************
c  MAIN
c***********************************************************************
c
c     This routine was completely rewritten in January 1994 for
c     version 6.0.  The input is now in a keyword format and is
c     handled in 'read5.f'. Calculations that were done within this
c     routine have now been moved so that this is just a calling
c     routine.
c
c     PROGRAM FOR POLYATOMIC VARIATIONAL TST CALCULATIONS
c
c     CALLS:
c          dorest,dorph,dorepr,dosage,dosafr,dopnm
c          elrph,headr,option,fiopen,initze,restor,dattim,title,setup,
c          rphwrt,rphset,react,saddle,center,trans,normod,path,
c          restrt,nextpt,rate,tsrate,fcinpt,fcmep,fcrate,
c          read5,setlgs,setvar
c
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
c
      include 'param.inc'
      include 'percon.inc'
      include 'common.inc'
c
      character*20 finame
      character*7  fistat
      logical lexit
c
c     Open the input and output files (fu5 and fu6).  All other
c     files will be opened later in fiopen.
c
c   Use the character variables FISTAT (file status), FINAME (filename), and
c   the subprogram OPENFI to open the input data file and the long output files
c   which are linked to FORTRAN units fu5 and fu6, respectively.
c
      lexit  = .false.
c
      fistat = 'unknown'
      finame = 'poly.fu6'
c
      call openfi (fu6, fistat, finame, lexit)
      if (lexit) go to 3000
c
      fistat = 'old'
      finame = 'poly.fu5'
c
      call openfi (fu5, fistat, finame, lexit)
c
c     Write out program header to unit fu6
      call headr 
c
c
c     this call needs to be integrated into the new format -- init routine
      call initze
c
c
c     Read in all input from unit 5 and write out the summary table
      call read5
c
c     Using keywords - set LGS flags to their correct values.  Here all
c     that do not depend on a stationary point will be set.
c     Later they will be altered for each successive reactant, product
c     and for the saddle point.
c
      call setlgs
c
c     Using the keywords set the variables to their correct values.  This
c     is a translator from the new interface to the old internal structure.
c     Here just the global parameters will be set (setvar).  Later they will
c     be altered for each successive reactant, product and saddle point using
c     stvarj. 
c
      call setvar
c
c     This subroutine was added to allow all files to be opened internally.
c     This is for compability with other machines and operating systems.
c
      call fiopen
c
c     Check options and read in fu50 for alll calculations except 
c     restart runs.  This is to allow a restart calculation where
c     VTST-IC was not requested in the original run but is desired
c     using the MEP stored on fu1.
c     This was modified on 1/4/96 by R. Steckler
c
      if (lgs(8).le.0) then
c
c        Read in unit fu50 for VTST-IC calculations
         if (lgs2(11) .ne. 0) call readic
c
c        Do IVTST calculations                                          07/95KAN
c                                                                       07/95KAN
         if (lgs2(38) .ge. 0 .and. lgs(8) .le. 0) then                  07/95KAN
           if (ipot.eq.3) then                                          0327YC97
            if (ifrfac.ne.0) then                                       0814JC00
            write (fu6,*) 'Error: IVTST and FREQSCALE is not supported' 0814JC00
            CALL FCRATE                                                 0814JC00
            stop 'IVTST ERROR'                                          0814JC00
            else                                                        0814JC00
              call givtst(nfcvt,isct,izct,                              07/95KAN
     >        ivtst,slpg,slmg,slp,slm,del,nedeg,elec,                   07/95KAN
     >        nratom,iatsv,xr,icode,nq12,nq22,ntemp,temp,natom,         07/95KAN
     >        redm,sigmaf,sigmar,xmass,iclasv)                          0808JC00
              write(fu6,4500)                                           09/95KAN
              CALL FCRATE
              stop 'IVTST DONE'                                         09/95KAN
            endif                                                       0814JC00
           else                                                         0327YC97
            write (fu6,*) 'Fatal error: IVTST required unit29 as ',     0327YC97
     >           'POTENTIAL'                                            0327YC97
            CALL FCRATE
            stop 'IVTST ERROR'
           endif
         endif                                                          09/95KAN
c
c        Check for consistencies between chosen options
         call option
c
c        Close the input data files which have been used up to this point.
         call fcinpt
      end if
c
c   **** POLYRATE calculations begin here: ********
c
c
c     Determine if it is a restart calculation: lgs(8)>0 for restart
c     If so, make sure lgs and variables are set at the value used
c     in the previous path calculations.
c
      IF (LGS(8).GT.0) THEN
         call dorest
         call option
         call fcinpt
         call prepj(5)
      else
C
C     Do the zero-order IVTST calculation
C
         if (lgsic(10) .eq. 1) then 
            call prepj(5)
            call zocupd            
            call rate             
            write(fu6,4500)     
            call fcrate        
            stop 'main 1'                                               0701YC97
         endif               
c
c                       Set up RPH information or potential surface
         call dorph 
c
c                       Optionally compute reactant and product properties
         call dorepr 
c
c        bath mode // we do not correct for reactants and products
c
         if (ibathm.eq.1) then                                          0317YC99
           LBATH = .true.                                               0317Yc99
           if (LGS2(39).GE.3) numint = numint + 1                       0317Yc99
         endif                                                          0317Yc99
c
c                       Compute saddle point and its energetics
c
         if (irepr(5).eq.1) then                                        0808YC97
         call prepj(5)

         call sadeng
c
c                      Calculate the parameters in the zero order ivtst
c                      correction for the classical energies and vibrational
c                      frequencies along the mep
c
        endif                                                           0808YC97
        if (lgs2(11).ne.0) then
           call zoc3p
           if (lgs(3) .ne. 0) call zocpar
           call zocprn
         endif                                                          09/95KAN
c
        if (lgs(3).ne.0) write (fu6,2900)
c
c
c                       compute steepest descents path and 
c                       projected normal modes along the path.
c     
         call prepj(6)                                                  0522RS95
         call dopnm 
         if (ipath.ne.0.and.lgs2(11).eq.0) call findl                   1203YC96
      endif
c
c   Close the input and output data files used up to this point.
c
      call fcmep
c
c   The path is now computed.  Here the rate constants are computed
c   without and optionally using the zero-order IVTST option.
c        lgs2(11) = 0   do not use VTST-IC-0
c        lgs2(11) = 1   do the corrected calculation only
c        lgs2(11) = 2   do the uncorrected first then the coorected
c     
      if (lgs2(11).ge.1) then
          if (lgs2(11).eq.2) then
             if (lgs(7).gt.0.or.lgs(9).ne.0) call rate
             if (lgs(7).le.-1) call tsrate
          endif
c
c     Update the information at each gts to include the zero order correction.
          call zocupd
          lzoc = .true. 
      endif            
c
c     if frequencies are scaled, do twice the calculation (only for non IC)
c
      if (ifrfac.ne.0) then
         ifrfac=0
         if (lgs(7).gt.0.or.lgs(9).ne.0) call rate
         if (lgs(7).le.-1) call tsrate
         ifrfac=1
         write(fu6,4400) 
         if (lgs(7).gt.0.or.lgs(9).ne.0) call rate
         if (lgs(7).le.-1) call tsrate
      else
         if (lgs(7).gt.0.or.lgs(9).ne.0) call rate
         if (lgs(7).le.-1) call tsrate
      endif
      write(fu6,4500) 
C
      if (lgs2(13) .ne.0 .or. lgs2(14) .ne. 0) call prmep               0706WH94
c
c     Plot the representative tunneling path in mass-scaled Jacobian    0411PJ01
c
      if(lgs3(3) .ne. 0) call rtpjac                                    0411PJ01
c
C
C   Close all remaining input and output data files.
C
      call fcrate
ctrace numstep
c               open (unit=99,file='polyout')
c               ishft = n3-nf(5)
c               write (99,*) dlx, conf(1),freq(ishft+1)*autocm,
c     *              wer(1)*AUTOCM,wer(nf(1)+nf(2)+1)*AUTOCM
c               close (99)
cend trace
      stop 'exit polyrate'                                              0701YC97
C
 2900 FORMAT(//1X,78(1H*),                                              0620WH94
     * /1X,'After this, all energies are given w/re to classical'
     * /1X,'reactants and output is in a.u. unless stated otherwise.',
     * /1X,78(1H*))
c
c  The error statement for units fu5 and fu6 are written to unit 6
c  (assumed to be standard out) because if there is a problem 
C  with units fu5 or fu6 then the code cannot use fu6 for its output
c  and the following error message may not be written.
C
 3000 WRITE (6, *) 'Error opening the long output file'
      CALL FCRATE
      STOP 'MAIN 5'                                                     0701YC97
 4400 FORMAT(//1X,21('*'),' CALCULATION WITH SCALED FREQUENCIES ',
     *       21('*'))
 4500 FORMAT(//1X,25('*'),' END OF POLYRATE LONG OUTPUT ',25('*'))
C
      END                                           
